searchNodes=[{"doc":"Adaptive concurrency limits.","ref":"Regulator.html","title":"Regulator","type":"module"},{"doc":"Ask for access to a protected service. Instead of executing a callback this function returns a dropped atom or a context. It is the callers responsibility to check the context map back in to the regulator using one of the corresponding functions. Care must be taken to avoid leaking these contexts. Otherwise the regulator will not be able to adjust the inflight count which will eventually deadlock the regulator.","ref":"Regulator.html#ask/1","title":"Regulator.ask/1","type":"function"},{"doc":"Ask for access to a protected service. If we've reached the concurrency limit then ask will return a :dropped atom without executing the callback. Otherwise the callback will be applied. The callback must return tuple with the result as the first element and the desired return value as the second. The available result atoms are: :ok - The call succeeded. :error - The call failed or timed out. This is used as a signal to backoff or otherwise adjust the limit. :ignore - The call should not be counted in the concurrency limit. This is typically used to filter out status checks and other low latency RPCs.","ref":"Regulator.html#ask/2","title":"Regulator.ask/2","type":"function"},{"doc":"Checks in a context and marks it as an error.","ref":"Regulator.html#error/1","title":"Regulator.error/1","type":"function"},{"doc":"Checks in a context and ignores the result.","ref":"Regulator.html#ignore/1","title":"Regulator.ignore/1","type":"function"},{"doc":"Creates a new regulator.","ref":"Regulator.html#install/2","title":"Regulator.install/2","type":"function"},{"doc":"Checks in a context and marks it as &quot;ok&quot;.","ref":"Regulator.html#ok/1","title":"Regulator.ok/1","type":"function"},{"doc":"Removes a regulator.","ref":"Regulator.html#uninstall/1","title":"Regulator.uninstall/1","type":"function"},{"doc":"","ref":"Regulator.html#t:result/0","title":"Regulator.result/0","type":"type"},{"doc":"","ref":"Regulator.html#t:token/0","title":"Regulator.token/0","type":"type"},{"doc":"Provides a behaviour for defining new limit algorithms","ref":"Regulator.Limit.html","title":"Regulator.Limit","type":"behaviour"},{"doc":"The initial limit.","ref":"Regulator.Limit.html#c:initial/1","title":"Regulator.Limit.initial/1","type":"callback"},{"doc":"Creates a new limit configuration.","ref":"Regulator.Limit.html#c:new/1","title":"Regulator.Limit.new/1","type":"callback"},{"doc":"Recalculates the new limit based on the previous limit, the most recent window, and the configuration for the limit. Must return the limit configuration with the new limit in a tuple.","ref":"Regulator.Limit.html#c:update/3","title":"Regulator.Limit.update/3","type":"callback"},{"doc":"Loss based dynamic limit algorithm. Additively increases the concurrency limit when there are no errors and multiplicatively decrements the limit when there are errors. To use this regulator you must specify a &quot;target average latency&quot;. Regulator collects measurements of your service calls and averages them over a sliding window. If the average latency is above the target specified, regulator considers it an error and will begin to multiplicatively decrease the concurrency limit. If the avg latency is below the target and over half of the concurrency tokens were utilized during the window, then regulator will increase the concurrency limit by a fixed value. If less than half of the concurrency tokens were utilized in the window, Regulator leaves the concurrency limit as is, since there is no need for additional tokens. Finally, if there was any errors that occured during the window, Regulator treats that as a backoff situation and will begin to reduce the concurrency limit. Options :min_limit - The minimum concurrency limit (defaults to 5) :initial_limit - The initial concurrency limit when the regulator is installed (deafults to 20) :max_limit - The maximum concurrency limit (defaults to 200) :step_increase - The number of tokens to add when regulator is increasing the concurrency limit (defaults to 10). :backoff_ratio - Floating point value for how quickly to reduce the concurrency limit (defaults to 0.9) :target_avg_latency - This is the average latency in milliseconds for the system regulator is protecting. If the average latency drifts above this value Regulator considers it an error and backs off. Defaults to 5. :timeout - alias for target_avg_latency .","ref":"Regulator.Limit.AIMD.html","title":"Regulator.Limit.AIMD","type":"module"},{"doc":"Limiter based on the gradient of change. Based on Netflix's gradient2 algorithm. https://github.com/Netflix/concurrency-limits. Options :initial_limit - The initial limit when the regulator is installed (defaults to 20). :min_limit - The minimum limit for the regulator (defaults to 5). :max_limit - The maximum limit for the regulator (defaults to 200). :smoothing - Determines how aggressively the concurrency limit can shrink if there is queueing. Numbers should be between 0.0 and 1.0. Higher numbers will cause the limit to shrink faster. :rtt_tolerance - Specifies how much change in average round trip time will be allowed before reducing the concurrency limit. A value of 2.0 would mean that a 2x increase in rtt would be acceptable. Default 1.5. :long_window_count - Defines the number of sample windows that will be considered in the long term moving average. Setting this value lower will cause the long term window to adjust more aggressively. Default 600.","ref":"Regulator.Limit.Gradient.html","title":"Regulator.Limit.Gradient","type":"module"},{"doc":"Fixed limit Options :limit - Statically defined limit","ref":"Regulator.Limit.Static.html","title":"Regulator.Limit.Static","type":"module"},{"doc":"A plug used for regulating the concurrency limit of an endpoint or series of endpoints. Options :regulator - Required. The regulator to use for this plug. :error_code - The status code to use when the concurrency limit is reached. Defaults to 403. :error_message - The message to return when the concurrency limit is reached. Must be a binary. Defaults to &quot;Overloaded&quot;.","ref":"Regulator.Plug.html","title":"Regulator.Plug","type":"module"},{"doc":"","ref":"Regulator.Plug.html#call/2","title":"Regulator.Plug.call/2","type":"function"},{"doc":"","ref":"Regulator.Plug.html#init/1","title":"Regulator.Plug.init/1","type":"function"},{"doc":"Regulator produces multiple telemetry events. Events [:regulator, :limit] - Returns the calculated limit Measurements :limit - The new limit Metadata :regulator - The name of the regulator [:regulator, :ask, :start] - Is called when asking for access to a protected service Measurements :inflight - The current inflight requests :system_time - The current, monotonic system time Metadata :regulator - The regulator name [:regulator, :ask, :stop] - Called immediately before an ask call returns. Measurements :duration - The amount of time taken in the regulator Metadata :regulator - The name of the regulator :result - The result of the call, either :ok , :dropped , :drop , or :ignore [:regulator, :ask, :exception] - Called if the callback passed to ask raises or throws Measurements :duration - The amount of time taken in the regulator Metadata :kind - The type of error :error - The error :stacktrace - The stacktrace :regulator - The regulator name","ref":"Regulator.Telemetry.html","title":"Regulator.Telemetry","type":"module"}]